diff --git a/gdb/dwarf2loc.c b/gdb/dwarf2loc.c
index bd630ee0588..c5145af7c66 100644
--- a/gdb/dwarf2loc.c
+++ b/gdb/dwarf2loc.c
@@ -2493,8 +2493,12 @@ dwarf2_evaluate_property (const struct dynamic_prop *prop,
 	struct value *val;
 
 	for (pinfo = addr_stack; pinfo != NULL; pinfo = pinfo->next)
-	  if (pinfo->type == baton->referenced_type)
-	    break;
+	  {
+	    /* This approach lets us avoid checking the qualifiers.  */
+	    if (TYPE_MAIN_TYPE (pinfo->type)
+		== TYPE_MAIN_TYPE (baton->referenced_type))
+	      break;
+	  }
 	if (pinfo == NULL)
 	  error (_("cannot find reference address for offset property"));
 	if (pinfo->valaddr != NULL)
diff --git a/gdb/testsuite/gdb.ada/vla.exp b/gdb/testsuite/gdb.ada/vla.exp
new file mode 100644
index 00000000000..7e10e9b8223
--- /dev/null
+++ b/gdb/testsuite/gdb.ada/vla.exp
@@ -0,0 +1,38 @@
+# Copyright 2019 Free Software Foundation, Inc.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+load_lib "ada.exp"
+
+if { [skip_ada_tests] } { return -1 }
+
+standard_ada_testfile vla
+
+if {[gdb_compile_ada "${srcfile}" "${binfile}" executable {debug}] != ""} {
+    return -1
+}
+
+clean_restart ${testfile}
+
+set bp_location [gdb_get_line_number "Set breakpoint here" ${testdir}/vla.adb]
+runto "vla.adb:$bp_location"
+
+gdb_test "print r00" \
+         "= \\(l1 => 0, l2 => 0, i1 => 1, i2 => 2, i3 => 3, a1 => \\(\\), a2 => \\(\\)\\)"
+gdb_test "print r01" \
+         "= \\(l1 => 0, l2 => 1, i1 => 1, i2 => 2, i3 => 3, a1 => \\(\\), a2 => \\(20\\)\\)"
+gdb_test "print r10" \
+         "= \\(l1 => 1, l2 => 0, i1 => 1, i2 => 2, i3 => 3, a1 => \\(10\\), a2 => \\(\\)\\)"
+gdb_test "print r22" \
+         "= \\(l1 => 2, l2 => 2, i1 => 1, i2 => 2, i3 => 3, a1 => \\(10, 10\\), a2 => \\(20, 20\\)\\)"
diff --git a/gdb/testsuite/gdb.ada/vla/vla.adb b/gdb/testsuite/gdb.ada/vla/vla.adb
new file mode 100644
index 00000000000..2b6cc8a1114
--- /dev/null
+++ b/gdb/testsuite/gdb.ada/vla/vla.adb
@@ -0,0 +1,57 @@
+--  Copyright 2019 Free Software Foundation, Inc.
+--
+--  This program is free software; you can redistribute it and/or modify
+--  it under the terms of the GNU General Public License as published by
+--  the Free Software Foundation; either version 3 of the License, or
+--  (at your option) any later version.
+--
+--  This program is distributed in the hope that it will be useful,
+--  but WITHOUT ANY WARRANTY; without even the implied warranty of
+--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+--  GNU General Public License for more details.
+--
+--  You should have received a copy of the GNU General Public License
+--  along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+procedure Vla is
+   type Array_Type is array (Natural range <>) of Integer;
+   type Record_Type (L1, L2 : Natural) is record
+      I1 : Integer;
+      A1 : Array_Type (1 .. L1);
+      I2 : Integer;
+      A2 : Array_Type (1 .. L2);
+      I3 : Integer;
+   end record;
+
+   procedure Process (R : Record_Type) is
+   begin
+      null;
+   end Process;
+
+   R00 : Record_Type :=
+     (L1 => 0, L2 => 0,
+      I1 => 1, A1 => (others => 10),
+      I2 => 2, A2 => (others => 20),
+      I3 => 3);
+   R01 : Record_Type :=
+     (L1 => 0, L2 => 1,
+      I1 => 1, A1 => (others => 10),
+      I2 => 2, A2 => (others => 20),
+      I3 => 3);
+   R10 : Record_Type :=
+     (L1 => 1, L2 => 0,
+      I1 => 1, A1 => (others => 10),
+      I2 => 2, A2 => (others => 20),
+      I3 => 3);
+   R22 : Record_Type :=
+     (L1 => 2, L2 => 2,
+      I1 => 1, A1 => (others => 10),
+      I2 => 2, A2 => (others => 20),
+      I3 => 3);
+
+begin
+   Process (R00); -- Set breakpoint here
+   Process (R01);
+   Process (R10);
+   Process (R22);
+end Vla;